; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; ________________________________________________
; |       Programma scheda didattica 8 led       |
; |_________________PROGRAMMA 1__________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : ASM                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 14/01/07                       |
; |______________________________________________|

;Attivazione di un'uscita

        LIST

    __CONFIG 0x2118
; Program code protection: OFF
; Data code protection: OFF
; LVP: OFF
; BODEN: OFF
; MCLRE: Vcc
; FOSC2: INTRC
; PWRT: OFF
; WDT: OFF
; FOSC1-0: RA6,RA7 = I/O
 

#include "P16F628A.inc"
#include "costanti.inc"
#include "variabili.inc"
#include "macro.inc"


 ORG RESET_VECTOR
;***************************************************************************
;                             START-UP SISTEMA
;***************************************************************************
SYS_STARTUP:

        CLI                             ;Disabilita master IRQ
        CLRF PORTA                      ;Inizializza PORTA
        MOVLF 0x07,CMCON                ;disabilita comparatori
        BANKSET 1                       ;Bank1
        MOVLF 0xB,PCON                  ;Setta osc. interno 4MHz
        MOVLF 0xFD,c_LED_TRIS           ;Setta pin LED come uscita
        BANKSET 0                       ;Bank0
        MOVLF 0xFF,c_LED_PORT           ;Spegne led

;***************************************************************************
;                           PROGRAMMA PRINCIPALE
;***************************************************************************
PROGRAM:
        BCF c_LED_PORT,c_LED_PIN        ;accende il led
        GOTO PROGRAM                    ;cicla qui

        END
