; ________________________________________________
; |   Sub per programma scheda didattica 8 led   |
; |______________________________________________|
; |   Src File                                   |
; |______________________________________________|
; |   Tipo      : INC                            |
; |   Versione  : 1                              |
; |   Release   : 0                              |
; |   Autore    : Lain Walter                    |
; |   Data      : 28/12/06                       |
; |______________________________________________|

;_______________________________________________________Inizializza variabili
Sysvar_Init:
;Inizializza le variabili di sistema
;Registri modificati:
;       sistema
;metodo di chiamata:
;       CALL Sysvar_Init
;
        BANKSET 0                       ;Bank0
        CLRF b_CONTROLLO                ;clear byte controllo
        CLRF b_STATO                    ;clear byte stato
        CLRF b_SW_CTRL                  ;clear byte controllo tastiera
        CLRF b_SW1_BUFF                 ;pulisce i buffer tastiera
        CLRF b_SW2_BUFF                 ;pulisce i buffer tastiera
        CLRF R1H                        ;variabili temporanee
        CLRF R1L
        CLRF R2H
        CLRF R2L
        CLRF R3H
        CLRF R3L
        RETURN                          ;fine


Timer_Exec:
;Questa routine gestisce i vari programmi
; E' necessario 1 byte di stato
;Registri modificati:
;       sistema
;       b_CONTROLLO
;       b_STATO
;       R0H
;       R0L
;       R3H
;metodo di chiamata:
;       CALL Timer_Exec
;
;prima di tutto, faccio lampeggiare il led "RUN"
        BTFSC c_RLED_PORT,c_RLED_PIN    ;controlla stato led "RUN"
        GOTO CS_RL1                     ; spento
        BSF c_RLED_PORT,c_RLED_PIN      ; acceso, lo spegne
        GOTO CS_RL2                     ;passa avanti
CS_RL1  BCF c_RLED_PORT,c_RLED_PIN      ; spento, lo accende
;quindi gestisco il resto
CS_RL2  BTFSS f_SW_SEL_CHG              ;controlla se cambiato stato pulsante selezione
        GOTO CS_SWP1                    ; no, passa a gestione programmi
        BCF f_SW_SEL_CHG                ;cambiamento recepito, clear flag
        BTFSC f_SW_SEL_STAT             ;controlla se pulsante premuto
        BSF f_ST_CHG                    ; si, set cambio stato

CS_SWP1 BTFSS f_ST_P1                   ;controlla se in esecuzione prog1
        GOTO CS_SWP2                    ; no, controlla prog2
        BTFSC f_ST_CHG                  ;controlla se cambio stato
        GOTO PRG_P2                     ; si, passa a init prog successivo
        GOTO PR_P11                     ; no, abilita esecuzione prog attuale

CS_SWP2 BTFSS f_ST_P2                   ;controlla se in esecuzione prog2
        GOTO CS_SWP3                    ; no, controlla prog3
        BTFSC f_ST_CHG                  ;controlla se cambio stato
        GOTO PRG_P3                     ; si, passa a init prog successivo
        GOTO PR_P21                     ; no, abilita esecuzione prog attuale

CS_SWP3 BTFSS f_ST_P3                   ;controlla se in esecuzione prog3
        GOTO CS_SWP4                    ; no, controlla prog4
        BTFSC f_ST_CHG                  ;controlla se cambio stato
        GOTO PRG_P4                     ; si, passa a init prog successivo
        GOTO PR_P31                     ; no, abilita esecuzione prog attuale

CS_SWP4 BTFSS f_ST_P4                   ;controlla se in esecuzione prog4
        GOTO CS_SWP5                    ; no, controlla prog5
        BTFSC f_ST_CHG                  ;controlla se cambio stato
        GOTO PRG_P5                     ; si, passa a init prog successivo
        GOTO PR_P41                     ; no, abilita esecuzione prog attuale

CS_SWP5 BTFSS f_ST_P5                   ;controlla se in esecuzione prog5
        GOTO CS_SWP6                    ; no, prog6
        BTFSC f_ST_CHG                  ;controlla se cambio stato
        GOTO PRG_P6                     ; si, passa a init prog successivo
        GOTO PR_P51                     ; no, abilita esecuzione prog attuale

CS_SWP6 BTFSS f_ST_P6                   ;controlla se in esecuzione prog6
        GOTO CS_SWEE                    ; no, errore
        BTFSC f_ST_CHG                  ;controlla se cambio stato
        GOTO PRG_P1                     ; si, passa a init prog successivo
        GOTO PR_P61                     ; no, abilita esecuzione prog attuale
        RETURN                          ;fine gestione

CS_SWEE BCF f_CTR_RUN                   ;errore programma, non dovrebbe essere qui
        RETURN                          ;fine gestione

PRG_P1  MOVLF c_FIRST_LED,R3H           ;inizializza prog1
        MOVLW c_ST_MASK                 ;
        ANDWF b_STATO,F                 ;clear stato prog e cambio stato
        BCF f_ST_CHG                    ;
        BSF f_ST_P1                     ;cambia flag stato programma
PR_P11  BSF f_CTR_P1                    ;set bit esecuzione
        RETURN                          ;fine gestione
PRG_P2  MOVLF c_LAST_LED,R3H            ;inizializza prog2
        MOVLW c_ST_MASK                 ;
        ANDWF b_STATO,F                 ;clear stato prog e cambio stato
        BCF f_ST_CHG                    ;
        BSF f_ST_P2                     ;cambia flag stato programma
PR_P21  BSF f_CTR_P2                    ;set bit esecuzione
        RETURN                          ;fine gestione
PRG_P3  MOVLF c_LAST_LED,R3H            ;inizializza prog3
        BSF f_CTR_DIR                   ;imposta direzione iniziale
        MOVLW c_ST_MASK                 ;
        ANDWF b_STATO,F                 ;clear stato prog e cambio stato
        BCF f_ST_CHG                    ;
        BSF f_ST_P3                     ;cambia flag stato programma
PR_P31  BSF f_CTR_P3                    ;set bit esecuzione
        RETURN                          ;fine gestione
PRG_P4  MOVLF 0xFF,R3H                  ;init prog4
        MOVLF c_FIRST_LED,R0H           ;carica led 0 sul byte "up"
        MOVLF c_LAST_LED,R0L            ;carica led 7 sul byte "down"
        MOVLW c_ST_MASK                 ;
        ANDWF b_STATO,F                 ;clear stato prog e cambio stato
        BCF f_ST_CHG                    ;
        BSF f_ST_P4                     ;cambia flag stato programma
PR_P41  BSF f_CTR_P4                    ;set bit esecuzione
        RETURN                          ;fine gestione
PRG_P5  MOVLF c_LAST_LED,R3H            ;inizializza prog5
        CLRF b_P5_PWM1                  ;azzera registri PWM
        CLRF b_P5_PWM2                  ;
        BSF f_CTR_DIR                   ;imposta direzione iniziale
        MOVLW c_ST_MASK                 ;
        ANDWF b_STATO,F                 ;clear stato prog e cambio stato
        BCF f_ST_CHG                    ;
        BSF f_ST_P5                     ;cambia flag stato programma
PR_P51  BSF f_CTR_P5                    ;set bit esecuzione
        RETURN                          ;fine gestione
PRG_P6  MOVLW c_ST_MASK                 ;
        ANDWF b_STATO,F                 ;clear stato prog e cambio stato
        BCF f_ST_CHG                    ;
        BSF f_ST_P6                     ;cambia flag stato programma
PR_P61  BSF f_CTR_P6                    ;set bit esecuzione
        RETURN                          ;fine gestione

Keyb_Run:
;Questa routine gestisce il pulsante "start/stop"
;Registri modificati:
;       sistema
;       R3H
;       b_CONTROLLO
;       b_STATO
;metodo di chiamata:
;       CALL Keyb_Run
;
        BTFSS f_SW_ST_CHG               ;controlla se cambiato stato pulsante start/stop
        RETURN                          ; no, esce
        BCF f_SW_ST_CHG                 ;cambiamento recepito, clear flag
        BTFSS f_SW_ST_STAT              ;controlla se pulsante premuto
        RETURN                          ; no, esce
        BTFSC f_CTR_RUN                 ;controlla stato flag esecuzione
        GOTO CS_STPE                    ; attivo, deve disattivare
        BSF f_CTR_RUN                   ; disattivo, attiva esecuzione
        BSF c_RLED_PORT,c_RLED_PIN      ;spegne led "RUN"
        RETURN                          ;esce
CS_STPE BCF f_CTR_RUN                   ;disattiva esecuzione programmi
        BCF c_RLED_PORT,c_RLED_PIN      ;accende led "RUN"
        MOVFF R3H,R3L                   ;salva R3H
        MOVLF 0xFF,R3H                  ;setta tutti i led spenti
        CALL Port_Write                 ;
        MOVFF R3L,R3H                   ;ripristina R3H
        RETURN                          ;fine sub
